#include "sndawk.h"
#include <stdio.h>

SVAR	*svariables;
/*
 * svariables est le pointeur vers la liste des svariables
 */

set_svar_val(name,val,acces)
	char	*name;
	float	val;
	ACCES	acces;
{
	SVAR	*svar, *last;

/*
 * Si svariables est NULL alors c'est la premiere svariable et on alloue 
 * l'espace necessaire pour une sttructure de type SVAR et on fait pointer
 * svariables vers elle. On met la valeur et l'acces.
 */
	if (svariables == NULL) {
		ALLOC(svariables, SVAR)
		svariables -> nom = name;
		svariables -> valeur = val;
		svariables -> acces = acces;
		return(0);
	}


/*
 * Sinon on cherche la svariable dans la liste.
 */
	for(svar = svariables; svar != NULL; svar = svar -> next){
		if(strcmp(name, svar -> nom) == 0) break;
		last = svar;
	}
	

/*
 * Si svar est NULL on ne l'a pas trouve et on alloue l'espace pour une
 * nouvelle structure laquele on l'ajoute en fin de liste.
 * si la variable etait la deja on retourne erreur.
 */
	if (svar == NULL) {
		ALLOC(svar, SVAR)
		svar -> nom = name;
		svar -> valeur = val;
		svar -> acces = acces;
		last -> next = svar;
		return(0);
	}
	return(-1);
}

